<template>
    <div class="app">
        <v-card class="vuety" max-width="1150px" min-height="600px" style="margin-left: 12%">
            <v-card-title class="bee-gray">
                <v-row justify="center">
                    <v-col cols="12">
                        <v-row align="center">
                            <v-col cols="3">
                                <a @click="$router.go(-1)">
                                    <img width="70px" src="~@/assets/icons/regresar.svg" alt srcset />
                                </a>
                            </v-col>
                            <v-col cols="2">
                                <h5 class="titleBack">Regresar</h5>
                            </v-col>
                        </v-row>
                    </v-col></v-row
                >
                <v-spacer></v-spacer>
            </v-card-title>

            <div class="d-flex black" style="width:100%; position: relative; margin-top:-220px;">
                <h1 class="ml-10 white--text">LISTADO PRODUCTOS</h1>
                <v-spacer></v-spacer>
            </div>
            <div class="d-flex" style="width:100%;">
                <v-row no-gutters align="center" style="height:60px;" class="bee-gray">
                    <v-col cols="1">
                        <v-spacer></v-spacer>
                    </v-col>
                </v-row>
            </div>

            <v-data-table
                :headers="headers"
                :items="dishesMenu"
                :search="search"
                style="position: relative; margin-top:-220px;"
            >
                <template v-slot:top>
                    <v-toolbar flat>
                        <v-btn
                            class="mb-2"
                            style="font-weight:bold; font-size: small; border-radius: 20px;"
                            color="#fbc02d"
                            @click="initDishDialog('add')"
                        >
                            AÑADIR PRODUCTO
                        </v-btn>
                        <v-spacer></v-spacer>
                        <span style="color: #72727f; font-weight:bold; padding-left: 5px; font-size: 1rem;"
                            >BUSCAR:</span
                        >
                        <v-text-field
                            v-model="search"
                            append-icon="mdi-magnify"
                            label="Nombre de Producto "
                            single-line
                            hide-details
                            color="black"
                            style="
                            max-width: 600px; 
                            padding-left: 10px; 
                            padding-right: 20px; 
                            text-justify: distribute-all-lines; 
                            background-color: #FFFFFF;"
                            class="searchAuto"
                        >
                        </v-text-field>
                    </v-toolbar>
                </template>

                <template v-slot:no-data>
                    <v-alert :value="true" color="alert">
                        No se encontro contenido para mostrar por el momento.
                    </v-alert>
                </template>

                <template v-slot:item="row">
                    <tr style="border-top:none;">
                        <td style="text-align: justify;">{{ row.item.name }}</td>
                        <td>
                            <v-btn :color="row.item.active ? 'success' : 'warning'">{{
                                row.item.active ? 'ACTIVO' : 'INACTIVO'
                            }}</v-btn>
                        </td>
                        <td>
                            <input
                                type="checkbox"
                                color="#F9A825"
                                v-model="row.item.delivery"
                                @change="itemselect(row.item.id, row.item.delivery, menuId)"
                            />
                        </td>
                        <td>
                            <span class="mr-5">{{ row.item.lastUpdated.toDate().toLocaleString() }}</span>
                        </td>
                        <td>
                            <HexButton class="small-button btnHex" @click="initDishDialog('edit', $event, row.item)">
                                <v-icon>mdi-pencil</v-icon>
                            </HexButton>
                        </td>
                        <td>
                            <HexButton class="small-button btnHex" @click="deleteDish(row.item)">
                                <v-icon>mdi-delete</v-icon>
                            </HexButton>
                        </td>
                    </tr>
                </template>
            </v-data-table>
            <v-dialog v-model="message.show" max-width="290">
                <v-alert
                    :value="message.show"
                    style="text-align:center; margin:0px;"
                    justify="center"
                    dismissible
                    :type="message.type"
                    @input="message.show = $event"
                    >{{ message.message }}</v-alert
                >
            </v-dialog>
        </v-card>
        <Dish
            :show-dialog="showDialog"
            :langs-menu="langsMenu"
            :categories="categoriesMenu"
            :subCategories="subCategoriesFromFire"
            :menu-id="menu.id"
            :dish="dish"
            :restaurant="restaurant"
            :action="action"
            @setShowDishModal="setShowDishModal"
            @saveDish="saveDish"
            @setMessage="setMessage"
        ></Dish>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { namespace } from 'vuex-class';
import { Category as CategoryModel } from '@/model/menu/Category';
import { Subcategory as SubCategoryModel } from '@/model/menu/Subcategory';
import { Dish as DishModel } from '@/model/menu/Dish';
import { LangMenu } from '@/model/menu/LangMenu';
import { LangText } from '@/model/LangText';
import { Menu as MenuModel } from '@/model/menu/Menu';
import { Price } from '@/model/menu/Price';
import { Restaurant } from '@/model/Restaurant';
import { DishService } from '@/services/DishService';
import HexButton from '@/components/commons/HexButton.vue';
import Dish from '@/components/dishes/Dish.vue';
import { CATEGORIES, DISH, MENU_LANG, MENUS, SUBCATEGORIES } from '@/config/collectionsName';
import { serializeCategory, serializeDish, serializeLangMenu, serializeSubCategory } from '@/config/serializables';
import { db } from '@/config/firebase';
import { newTimestamp } from '@/config/serializables';
import { MenuService } from '@/services/MenuService';

const menuStore = namespace('MenuModule');

@Component({
    components: {
        Dish,
        HexButton
    }
})
export default class DishesMenu extends Vue {
    @Prop()
    restaurant!: Restaurant;
    @menuStore.State
    menu!: MenuModel;

    @menuStore.Action
    findMenuById!: (menuId: string) => Promise<void>;

    @menuStore.Action
    changeStatusTypeService!: (payload: { dishId: string; delivery: boolean }) => Promise<void>;
    private readonly menuService = new MenuService();

    categoriesMenu: CategoryModel[] = [];
    subCategoriesFromFire: { [key: string]: { subCategories: SubCategoryModel[] } } = {};
    dish = new DishModel('', false, '', false, -1, false, '', '', false, -1, '', -1, [], newTimestamp(), '', '');
    dishesMenu: DishModel[] = [];
    langsMenu: LangMenu[] = [];
    showDialog = false;
    action = '';
    dishService = new DishService();

    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };
    search = '';
    headers = [
        {
            text: 'NOMBRE',
            align: 'center',
            sortable: true,
            value: 'name'
        },
        {
            text: 'ESTATUS',
            align: 'center',
            sortable: true,
            value: 'name'
        },
        {
            text: 'SERVICIO DE DELIVERY',
            align: 'center',
            sortable: true,
            value: 'id'
        },
        {
            text: 'ULTIMA MODIFICACIÓN',
            align: 'center',
            sortable: true,
            value: 'id'
        },
        {
            text: 'EDITAR',
            align: 'center',
            sortable: false,
            value: 'id'
        },
        {
            text: 'ELIMINAR',
            align: 'center',
            sortable: false,
            value: 'id'
        }
    ];

    items = ['ACTIVOS', 'INACTIVOS'];

    get menuId(): string {
        const menu = this.menu.id;
        return menu;
    }

    setShowDishModal(show: boolean) {
        this.showDialog = show;
    }

    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error', show: boolean) {
        this.message = { message: message, type: type, show: show };
    }

    initDishDialog(action = '', event: Event, dish?: DishModel) {
        this.action = action;
        if (!dish) {
            dish = new DishModel(
                '',
                false,
                '',
                false,
                -1,
                false,
                '',
                '',
                false,
                -1,
                '',
                -1,
                [],
                newTimestamp(),
                '',
                ''
            );
        }
        this.dish = dish;
        this.setShowDishModal(true);
    }

    async saveDish(dish: DishModel, fileDish: File[], langsName: LangText[], langsDes: LangText[], price: Price[]) {
        if (dish.id) {
            await this.dishService.updateDish(
                this.menu.id,
                dish,
                fileDish,
                langsName,
                langsDes,
                price,
                this.restaurant
            );
            this.setMessage('PRODUCTO ACTUALIZADO', 'success', true);
            return;
        }
        await this.dishService.createDish(this.menu.id, dish, fileDish, langsName, langsDes, price, this.restaurant);
        this.setMessage('PRODUCTO GUARDADO', 'success', true);
        return;
    }

    async deleteDish(dish: DishModel) {
        if (confirm(`¿Deseas eliminar el producto ${dish.name.toUpperCase()}?`)) {
            await this.dishService.deleteDish(this.menu.id, dish);
            this.setMessage('PRODUCTO ELIMINADO', 'info', true);
            return;
        }
    }

    async created() {
        await this.findMenuById(this.$route.params.menuId);

        await this.$bind(
            'categoriesMenu',
            db
                .collection(MENUS)
                .doc(this.$route.params.menuId)
                .collection(CATEGORIES),
            { serialize: serializeCategory, reset: false }
        );

        await this.$bind(
            'dishesMenu',
            db
                .collection(MENUS)
                .doc(this.$route.params.menuId)
                .collection(DISH),
            { serialize: serializeDish }
        );

        await this.$bind(
            'langsMenu',
            db
                .collection(MENUS)
                .doc(this.$route.params.menuId)
                .collection(MENU_LANG),
            { serialize: serializeLangMenu }
        );

        for (const cat of this.categoriesMenu) {
            this.subCategoriesFromFire[cat.id] = { subCategories: [] };
            await this.$bind(
                `subCategoriesFromFire.${cat.id}.subCategories`,
                db
                    .collection(MENUS)
                    .doc(this.$route.params.menuId)
                    .collection(CATEGORIES)
                    .doc(cat.id)
                    .collection(SUBCATEGORIES),
                { serialize: serializeSubCategory }
            );
        }
    }

    async itemselect(dishId: string, delivery: boolean, menuId: string) {
        await this.menuService.updateStatusTypeService(
            {
                dishId: dishId,
                delivery: delivery
            },
            menuId
        );
        alert('EL TIPO DE SERVICIO PARA ESTE PRODUCTO HA CAMBIADO');
    }
}
</script>
<style type="text/css">
.btnHex {
    display: inline-grid;
}
</style>
